import { ReactNode, ComponentType } from 'react';
declare type ComponentTuple<T = any> = [Component: ComponentType<T>, props?: T];
export declare type Wrapper<T = any> = ComponentType<T> | ComponentTuple<T>;
interface Props<T = any> {
    /** Compose these components. Can be a ReactComponent, or a [ReactComponent, Props] tuple */
    components: Wrapper<T>[];
    children?: ReactNode;
}
/**
 * A react Component composer. equivalent to `(n+1) => <a[n+1]> <Compose(a[n]) /> </a[n+1]>`.
 * Component can be a React Component, or a `[Component, { ...props }]` tuple.
 */
export declare function Compose(props: Props): JSX.Element;
export {};
